## $Id: test_product.py 12069 2014-11-27 08:18:21Z henrik $
##
## Copyright (C) 2014 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""
Tests for products.
"""
from zope.interface.verify import verifyClass, verifyObject
from zope.component import createObject
from hurry.workflow.interfaces import (
    IWorkflowInfo, IWorkflowState, InvalidTransitionError)
from waeup.ikoba.products.interfaces import (
    IProductsContainer, IProduct)
from waeup.ikoba.interfaces import IObjectHistory
from waeup.ikoba.products.container import ProductsContainer
from waeup.ikoba.products.product import Product
from waeup.ikoba.testing import (FunctionalLayer, FunctionalTestCase)

class ProductsContainerTestCase(FunctionalTestCase):

    layer = FunctionalLayer

    def test_interfaces(self):
        # Make sure the correct interfaces are implemented.
        self.assertTrue(
            verifyClass(
                IProductsContainer, ProductsContainer)
            )
        self.assertTrue(
            verifyObject(
                IProductsContainer, ProductsContainer())
            )
        self.assertTrue(
            verifyClass(
                IProduct, Product)
            )
        self.assertTrue(
            verifyObject(
                IProduct, Product())
            )
        return

    def test_addProduct(self):
        container = ProductsContainer()
        product = createObject(u'waeup.Product')
        container.addProduct(product)
        self.assertRaises(TypeError, container.addProduct, object())
        self.assertEqual(product.product_id, 'NA')
        self.assertEqual(container['NA'], product)
        return
